/* File: fake.c
 *
 * fake is a dumb client for the transmission and reception of data.
 * It reads data from a file and writes data to another file. It is the 
 * replacement for floodread and floodwrite and combines the two programs
 * in one.
 */

#include <stdio.h>
#include <process.h>
#include <stdlib.h>
#include <cglob.h>
#include <types.h>
#include <signal.h>
#include "drvinterface.h"

int main(int argc, char* argv[]) {
	char in_buffer[1024]; /* must be multiple of 1024 */
	char* in_bpos = in_buffer;
	char out_buffer[256];
	int count,e,sz;
	u_int32 ticks;
	FILE *fin;
	FILE *fout;

	if (argc<3) {
		printf("usage: %s <source data file> <dest. data file>\n Transmits data from input file to port and writes data received to outdata",argv[0]);
		_os_exit(1);
	} 
	
	
	fin = fopen(argv[1],"rb");
	if (!fin) {
		printf("%s: failed opening the file '%s'!\n",argv[0], argv[1]);
		_os_exit(2);
	}
	
	fout = fopen(argv[2], "wb");
	if (!fin) {
		printf("%s: failed opening the file '%s'!\n",argv[0], argv[2]);
		_os_exit(3);
	}
	
	printf("%s: starting driver...\n",argv[0]);	
	if (e=InitDrv()) {
		printf("%s: error connecting to driver: %i\n",argv[0],e);
		_os_exit(4);
	}


	printf("%s: preparing to receive...\n",argv[0]);
	StartBufferRead( in_buffer,sizeof(in_buffer) );
	
	count=0;
	int_write=1;
	while ( !int_end ) {
		if (int_write) {
			if ( !feof(fin) ) {
				sz = fread(out_buffer,1,sizeof(out_buffer),fin);
				if (sz>0) {
					count++;
					printf("%s: Transmitting %i block of data (%i bytes)...\n", argv[0], count, sz);
					StartBufferWrite(out_buffer,sz);
				}
			}
		}
		ticks=0;
		_os9_sleep(&ticks);

		if (int_read>256) {
			fwrite(in_bpos,1,256,fout);
			in_bpos += 256;
			if ( (in_bpos-in_buffer)>=sizeof(in_buffer) )  /* wrap around in in-buffer */
				in_bpos=in_buffer;
			int_read -= 256;
		}
	}
	
	printf("%s: had %i bytes waiting in in-buffer...\n",argv[0],int_read);
	if (int_read) {
		fwrite(in_bpos,1,int_read,fout);
	}

	printf("%s: closing driver...\n",argv[0]);
	CloseDrv();
	
	printf("%s: closing files...\n",argv[0]);
	fclose(fin);
	fclose(fout);
	
	printf("%s: exiting...\n",argv[0]);
	_os_exit(0);
}
