/* File: floodread.c
 * This program tests the device driver by reading as fast as machinably
 * possible from the device and thereby consuming all power...
 *
 */

#include <stdio.h>
#include <process.h>
#include <cglob.h>
#include <types.h>
#include "drvinterface.h"


void dumpmem(char* base, int size) {
	int lp1, lp2;
	
	lp2=0;
	while (lp2<size) {
		printf("%08x: [", base );
		for (lp1=0;lp1<16 && lp2<size;lp1++) {
			printf("%02x ", *(base++) );
			lp2++;
		}
		printf("]\n");
	}
}



int main(int argc, char* argv[]) {
	char buffer[100];/*0x280*/
	int lp1,lp2,e;
	
	printf("%s: starting driver...\n",argv[0]);	
	if (e=InitDrv()) {
		printf("%s: error connecting to driver: %i\n",argv[0],e);
		_os_exit(1);
	}

	for (lp1=0;lp1<sizeof(buffer);lp1++)  buffer[lp1]=0;
/*	dumpmem( buffer,sizeof(buffer) );
*/
	printf("%s: ready to get flooded...\n",argv[0]);
	StartBufferRead( buffer,sizeof(buffer) );
	lp1=0;
	WaitRead();
	while ( buffer[lp1] ) {
		WaitRead();
		lp1++;
		if (lp1>=sizeof(buffer)) lp1=0;
	}


	dumpmem(buffer, sizeof(buffer) ); 
	printf("\n\n%s: got '%s'\n",argv[0],buffer);
	printf("%s: yeahh, made it!...closing driver and exiting...\n",argv[0]);
	
	CloseDrv();
	
	_os_exit(0);
}
