/* File: sigterm.c
 * Sends signal 3 to process ID supplied on command line
 */

#include <types.h>
#include <errno.h>
#include <modes.h>
#include <signal.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>

#define SIG_TERM 3

int main(int argc, char* argv[]) {
	process_id target;
	status_code status;
	error_code err;
	
	if (argc<2) {
		printf("usage: %s <process id>\nSends <ctrl>-c to process id.\n",argv[0]);
		_os_exit(1);
	}

	target = atoi(argv[1]);
	printf("%s: sending SIG_TERM to %d...\n",argv[0],target);
	err=_os_send(target,SIG_TERM);
	if (err) printf("%s: error %03d:%03d!\n",argv[0],err>>8,err&0xff);

	_os_exit(0);
}
	
