#ifndef STATUS_H
#define STATUS_H

#define SS_Cancel_Read  140
#define SS_Cancel_Write 141
#define SS_Read         142
#define SS_Write        143
#define SS_BufWrite     144 /* pass pointer to BufferCmd_t in param */
#define SS_BufRead      145 /* pass pointer to BufferCmd_t in param */

#define SIG_DONEREAD 201
#define SIG_DONEWRITE 202

#include <signal.h>

/* This structure is used when a buffered read/write is requested. A
 * pointer to the structure is passed as a parameter to the device 
 * driver request routine. The pointer start should point to the first
 * character in the buffer, whereas the end pointer should point to the
 * first character AFTER the buffer!
 */
typedef struct {
	signal_code signal;
	char* start;
	char* end;
} BufferCmd_t;

#endif
