/* File: test.c
 * This program tests the devicedriver using the drvinterface.
 *
 */

#include <stdio.h>
#include <process.h>
#include <cglob.h>
#include <types.h>
#include "drvinterface.h"


int main(int argc, char* argv[]) {
	int status, e, sz;
	char byte;
	char msg[]="Hello world!";

	printf("%s: starting driver...\n", argv[0]);
	e=InitDrv();
	if (e) printf("%s: failed with exit code %d!\n", argv[0], e);

	printf("%s: Attempting to write a char...\n", argv[0]);
	if (StartWrite('a')) {
		printf("%s: Error starting write!\n", argv[0]);
	} else
		WaitWrite();
	printf("%s: done writing...\n",argv[0]);
	
	sz=strlen(msg);
	printf("%s: Attempting to write buffer '%s' of %d chars...\n", argv[0], msg, sz);	
	if (StartBufferWrite(msg,sz)) {
		printf("%s: Error starting write!\n", argv[0]);
	} else
		WaitWrite();
	printf("%s: done writing...\n",argv[0]);


	printf("%s: Attempting to read a char...\n", argv[0]);
	printf("%s: (press ctrl+c to abort)\n", argv[0]);
	if (e=StartRead(&byte)) {
		printf("%s: Error starting read, code:%i\n", argv[0], e);
	} else
		e = WaitRead();
	printf("%s: status: %x\n", argv[0], e);
	printf("%s: read the character '%c'\n",argv[0],byte);
	
	printf("%s: clearing buffer...\n",argv[0]);
	for (sz=0;sz<sizeof(msg);sz++) 
		msg[sz]=0;
	printf("%s: Attempting a buffered read of 4 chars...\n", argv[0]);
	printf("%s: (press ctrl+c to abort)\n", argv[0]);
	if ( e=StartBufferRead(msg,sizeof(msg)) ) {
		printf("%s: Error starting buffered read, code:%i\n", argv[0], e);
	} else
		for (sz=0;sz<4;sz++) WaitRead();
	printf("%s: read the characters '%s'\n",argv[0],msg);
	
	
	printf("%s: closing driver and exiting...\n",argv[0]);
	CloseDrv();

	_os_exit(0);
}
