#include <stdio.h>
#include <stdlib.h>
#include <os9timing.h>	 
#include <iau_mat.h>

void emadd( matrix *ptm1, matrix *ptm2, matrix *ptm3 )
{
	register int i,j;

}

void imadd( matrix *ptm1, matrix *ptm2, matrix *ptm3 )
{
	register int i,j;

	/* Add the two matrices element by element */
	for ( i=0;i<ptm2->row;i++ )
	{
		for ( j=0; j < ptm2->col; j++ )
			ptm1->mat[i][j] = ptm2->mat[i][j] + ptm3->mat[i][j];
	}
}

void iemadd( matrix *ptm1, matrix *ptm2, matrix *ptm3 )
{
	register int i,j;


	/* Add the two matrices element by element */
	for ( i=0;i<ptm2->row;i++ )
	{
		for ( j=0; j < ptm2->col; j++ ) {}
	}
}

void pmadd( matrix *ptm1, matrix *ptm2, matrix *ptm3 )
{
	register double *a,*b,*c,*d;

	a = ptm1->mat[0];
	b = ptm2->mat[0];
	c = ptm3->mat[0];
	d = &(ptm1->mat[ptm1->row-1][ptm1->col-1]) + 1;
	
	/* Add the two matrices element by element using pointers*/
 	while ( a != d ) {
		*a++ = *b++ + *c++;
	}
}

void amadd( matrix *ptm1, matrix *ptm2, matrix *ptm3 )
{

_asm("
	movem.l	a3/a2/a1/a0,-(sp)
	move.l	%0,a0
	move.l	%1,a1
	move.l	%2,a2
	move.l	%3,a3
	bra	test
next:
	fmove.d	(a1)+,fp0
	fadd.d	(a2)+,fp0
	fmove.d	fp0,(a3)+
test:
	cmp.l	a3,a0
	bne	next
	movem.l	(sp)+,a3/a2/a1/a0",
	&(ptm1->mat[ptm1->row-1][ptm1->col-1]) + 1,
	ptm2->mat[0],
	ptm3->mat[0],
	ptm1->mat[0]
);		
}

void main(int argc, char *argv[])
{
	matrix *a,*b,*c;
	int i, matsize, no_iter;
	unsigned int t1,t2;
	double res;
	
	if (argc == 3) {
		matsize = atoi(argv[1]);
		no_iter = atoi(argv[2]);
	} else {
		printf("Usage: %s matsize no_iter\n",argv[0]);
		exit(1);
	}
	/* Allocate matrixes a,b and c  */ 
	a=mmake(matsize,matsize); b=mmake(matsize,matsize); c=mmake(matsize,matsize);
	/* Initialize a and b with random numbers */
	mrand(a); mrand(b);
	/* Open and reset timer */
	opentim();
	resettim();
	for (i = 0; i < no_iter; i++) {
		emadd(c,a,b); 
	}
	t1 = READTIM;
	printf("The empty routine test emadd:	 %lg us", t1*usecs_per_tick()/no_iter);
	printf("\n");

	resettim();
	for (i = 0; i < no_iter; i++) {
		iemadd(c,a,b); 
	}
	t1 = READTIM;
	printf("The empty loop test iemadd:	 %lg us", t1*usecs_per_tick()/no_iter);
	printf("\n");

	resettim();
	for (i = 0; i < no_iter; i++) {
		imadd(c,a,b); 
	}
	t1 = READTIM;
	printf("The index based test imadd:	 %lg us", t1*usecs_per_tick()/no_iter);
	printf("\n");

	resettim();
	for (i = 0; i < no_iter; i++) {
		pmadd(c,a,b); 
	}
	t1 = READTIM;
	printf("The pointer based test pmadd:	 %lg us", t1*usecs_per_tick()/no_iter);
	printf("\n");

	resettim();
	for (i = 0; i < no_iter; i++) {
		amadd(c,a,b); 
	}
	t1 = READTIM;
	printf("The assembler based test amadd:	 %lg us", t1*usecs_per_tick()/no_iter);
	printf("\n");

/*	mprint(c);
	mprint(a);
	mprint(b);	*/
	
	mfree(a); mfree(b); mfree(c);

}
