/* clock.c
 * Exercise 4.1 - outputs clock to screen every second.
 *
 */
#include <stdio.h>
#include <process.h>
#include <time.h>
#include <alarm.h>
#include <signal.h>
#include <types.h>

#define WAKEUP_CODE 1 /* The wake up signal code is 1 in OS-9 */
/* Macro for testing return value of fct. and cause exit */
#define _TEST(a,start,end,err) printf(start); \
	if (a) { printf(err); return 0; } \
	else printf(end);
#define TEST(a,start,end,err) a;


struct gtime_t { 
	u_int8 reserved;
	u_int8 hour;
	u_int8 min;
	u_int8 sec; 
};

struct gdate_t { 
	u_int16 year; 
	u_int8 month;
	u_int8 day;
};

int main(void) {
	alarm_id id;
	u_int32 ticks;
	u_int16 day;
	u_int32 gtticks;
	struct gtime_t gtime;
	struct gdate_t gdate;

	printf("\x1bH\x1bJ");
	printf("\x1b&a%iy%iC",0,1);
	TEST(_os_alarm_cycle( &id, WAKEUP_CODE, CLOCKS_PER_SEC ),
		"_os_alarm_cycle()...",
		"done\n",
		"Error starting the alarm cycle");
	
	while (1) {
		ticks=0;
		TEST(_os9_sleep(&ticks),
			"Entering sleep...",
			"done sleeping\n",
			"sleep failed\n");
		
		TEST(_os9_getime(0, (u_int32*)&gtime, (u_int32*)&gdate, &day, &gtticks ),
			"Getting time...\n",
			"done\n",
			"failed\n");
			
		/*printf("\x1bH\x1bJ");*/
		printf("\x1b&a1y60C%04d-%02d-%02d %02d:%02d:%02d\n",gdate.year,gdate.month,gdate.day,gtime.hour,gtime.min,gtime.sec);
	}
}
