/* clockcli.c
 * This is the client for the clock pipe system. It reads the clock
 * from the ascii stream
 */
 
#include <stdio.h>
#include <process.h>
#include <time.h>
#include <alarm.h>
#include <signal.h>
#include <types.h>
#include <stdlib.h>
#include <dexec.h>
#include <modes.h>
#include <sysio.h>
#include <cglob.h>
#include <string.h>

int main(int argc, char *argv[]) {
	char buffer[32];
	path_id pathid;
	u_int32 count, strlen;
	int quit=0;
	printf("%s started...\n", argv[0]);
	if (argc<2) {
		printf("usage: %s <pipe-name>\nRuns and reads from pipe	/pipe-name until quit recieved\n",argv[0]);
		return 1;
	}
	
	if (!_os_open(argv[1],READ_,&pathid)) {
		do {
			count = sizeof(strlen);
			_os_read(pathid,&strlen,&count);
			_os_read(pathid, buffer, &strlen);
			quit = !strcmp(buffer, "quit");
			if (!quit) {
				printf("%s", buffer);
			}
		}
		while(!quit);
		printf("exiting %s\n", argv[0]);
		_os_close(pathid);
	}	
	_os_exit(0);
}
