/* File: dmread.c
 *
 * This program reads a date from a protected memory area, outputs the date to 
 * screen and exits.
 *
 */

#include <stdio.h>
#include <string.h>
#include <process.h>
#include <types.h>
#include "dmclock.h"

int main(int argc, char *argv[]) {
	mh_com *mhead;
	struct mdate_t *date;
	u_int16 attr_rev, type_lang;
	char memname[64];
	char *memn = memname;
	error_code err;
	
	printf(" starting %s\n", argv[0]);
	attr_rev = mkattrevs(MA_REENT, 0);
	type_lang = mktypelang(MT_ANY, ML_ANY);
	strcpy(memname, argv[1]);
	printf(" attempting to link to: %s\n", memname);
	if (!(err=_os_link(&memn, &mhead, (void**)&date, &type_lang, &attr_rev))) {
		printf(" linked to: %s\n", memname);
		printf(" %s\n", date->date);
		_os_unlink(mhead);
	}
	else {
		printf(" failed linking to shared memory '%s'\n",memn);
	}
	printf(" errcode: %d\n", err);
	printf(" exiting %s\n", argv[0]);
	_os_exit(0);
}
