/* File: dmwrite.c
 *
 * This program allocates a memory area, writes a date to it, spawns dmread, 
 * waits for it to exit, deallocates the memory area and exits.
 *
 */

#include <stdio.h>
#include <process.h>
#include <types.h>
#include <time.h>
#include <cglob.h>
#include <sysio.h>
#include "dmclock.h"

struct gtime_t { 
	u_int8 reserved;
	u_int8 hour;
	u_int8 min;
	u_int8 sec; 
};

struct gdate_t { 
	u_int16 year; 
	u_int8 month;
	u_int8 day;
};

int main(int arvc, char *argv[]) {
	u_int32 ticks;
	u_int16 day;
	u_int32 gtticks;
	struct gtime_t gtime;
	struct gdate_t gdate;
	char *argchild[3];
	process_id childid;
	u_int16 attr_rev, type_lang;
	char orphan = 0;
	status_code childerr;
	char *memname = "h6data";
	u_int32 memsize = sizeof(struct mdate_t);
	struct mdate_t *date;
	mh_data *modhead;

	printf("starting %s\n", argv[0]);
	argchild[0] = "dmread";
	argchild[1] = memname;
	argchild[2] = NULL;
	
	/* allocate memory area */
	attr_rev = mkattrevs(MA_REENT, 0);
	type_lang = mktypelang(MT_ANY, ML_ANY);
	if (!_os_datmod(memname, memsize, &attr_rev, &type_lang, MP_OWNER_READ | MP_OWNER_WRITE, (void **)&date, &modhead)) {
		printf("created %s\n", memname);
		/* get time */
		_os9_getime(0, (u_int32*)&gtime, (u_int32*)&gdate, &day, &gtticks );
		/* write to memory area */
		sprintf(date->date,"%04d-%02d-%02d %02d:%02d:%02d\n",gdate.year,gdate.month,gdate.day,gtime.hour,gtime.min,gtime.sec);
		
		/* spawn child process */
		type_lang = mktypelang(MT_PROGRAM, ML_OBJECT);
		if (!_os_exec(_os_fork, 0, 3, argchild[0], argchild, _environ, 0, &childid, type_lang, orphan )) {
								/* priority=0, pathcnt=4, modname, arguments, envvars, stacksize=0(default) */
			printf("starting child %s, wating to end\n", argchild[0]);								
			/* wait for child to exit */
			_os_wait(&childid, &childerr);
			
		}
		/* deallocate memory area */
		_os_unlink((mh_com*)modhead);
	}
	else {
		printf("allocating memory failed\n");								
	}
	/* exit */
	printf("exiting %s\n", argv[0]);
	_os_exit(0);
}
