/* File: dmread.c
 *
 * This program reads a date from a protected memory area, outputs the date to 
 * screen and exits when exitflag is set in memory.
 *
 */

#include <stdio.h>
#include <string.h>
#include <process.h>
#include <types.h>
#include <semaphore.h>
#include "dmclock.h"

int main(int argc, char *argv[]) {
	mh_com *mhead;
	struct mdate_t *date;
	u_int16 attr_rev, type_lang;
	char memname[64];
	char *memn = memname;
	int exit;
	
	printf("%s: starting...\n", argv[0]);
	attr_rev = mkattrevs(MA_REENT, 0);
	type_lang = mktypelang(MT_ANY, ML_ANY);
	strcpy(memname, argv[1]);
	printf("%s: attempting to link to %s...\n", argv[0], memname);
	if (!_os_link(&memn, &mhead, (void**)&date, &type_lang, &attr_rev)) {
		_os_sema_p( &(date->mem) );
		exit = date->exit;
		_os_sema_v( &(date->mem) );
		while (!exit) {
			_os_sema_p( &(date->next) );
			_os_sema_p( &(date->mem) );
			printf("%s: %s\n", argv[0], date->date);
			exit = date->exit;
			_os_sema_v( &(date->mem) );
		}		
		_os_unlink(mhead);
	} else {
		printf("%s: failed linking to shared memory '%s'\n", argv[0], memn);
	}
	printf("%s: exiting...\n", argv[0]);
	_os_exit(0);
}
